<?xml version="1.0"?>

<st-source>
<!-- Changes in change set 2010-06-03-SAM-Interface-diffs -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on June 3, 2010 at 2:09:49 pm</time-stamp>


<methods>
<class-id>PROVISO.PvUniversalOutputWriter</class-id> <category>writing</category>

<body package="PV-NM-Inventory-Application" selector="endWriteSubelement:property:">endWriteSubelement: modelSubelement property: aProperty 
	
	| isDirty |
	isDirty := false.
	self pvModel formulaManager 
		itemNamed: aProperty name
		ifPresent: 
			[:formula | 
			modelSubelement 
				propertyAtFormula: formula
				ifPresent: 
					[:modelProperty | 
					modelProperty value ~= aProperty value 
						ifTrue: 
							[modelProperty
								value: aProperty value;
								date: self currentSeconds.
							self bulkInserter addUpdatedProperty: modelProperty.
							isDirty := true.
							self system 
								logDebugFive: #UPDATE_PROPERTY
								messageId: nil
								template: 
									'Updating property on subelement for metricId: &lt;1p&gt;, resourcId: &lt;2p&gt;, name: &lt;3s&gt; value: &lt;4s&gt;, timestamp: &lt;5p&gt;'
								arguments: 
									(Array 
										with: modelProperty metricId
										with: modelProperty resourceId
										with: modelProperty name asString
										with: modelProperty value asString
										with: modelProperty date)]]
				ifAbsent: 
					[aProperty
						resourceId: modelSubelement id;
						metricId: formula id;
						date: self currentSeconds.
					modelSubelement addProperty: aProperty.
					self bulkInserter addNewProperty: aProperty.
					isDirty := true.
					self system 
						logDebugFive: #ADD_PROPERTY
						messageId: nil
						template: 
							'Adding property on subelement for metricId: &lt;1p&gt;, resourcId: &lt;2p&gt;, name: &lt;3s&gt; value: &lt;4s&gt;, timestamp: &lt;5p&gt;'
						arguments: 
							(Array 
								with: aProperty metricId
								with: aProperty resourceId
								with: aProperty name asString
								with: aProperty value asString
								with: aProperty date)]]
		ifAbsent: [self logMissingPropertyName: aProperty].
	^isDirty</body>
</methods>


<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>processing</category>

<body package="SAM-Interface" selector="updateModelInterfaceWithTimestamp:">updateModelInterfaceWithTimestamp: timestamp 
	
	timestamp ifNotNil: 
		[self currentApplication server firstAdaptor modelInterface currentDate: timestamp.
		Smee.SmeeEnvironment current currentTimestamp: 
			self currentApplication server firstAdaptor modelInterface currentDate]</body>
</methods>



</st-source>
